% Programm aufg56_wert zur Berechnung eines kubischen Splines (periodisch)
% Berechnung des Wertes s(xx) eines kubischen Splines
% fuer die Stuetzpunkte (x_0,y_0),...,(x_n,y_n)
% input:  Vektoren x(1:n+1), y(1:n+1), Stelle xx
% output: Wert des Splines s(xx)
% berechnet wird ein interpolierender Spline
% benutzte Funktionen: splabl_per, splber_per
% aufruf: fwert = aufg56_wert(xx,x,y);
function [fwert] = aufg56_wert(xx,x,y);
n=length(x)-1;
ys = splabl_per(x,y,n);
fwert = splber_per(xx,x,y,ys,n);
end
