% Programm aufg8.3
% Aufruf: [xx,yy] = aufg83(h,iwahl);
% iwahl: 1 Euler explizit, 2 verbesserte Polygonzugmethode, 3 Heun 3. Ordn.
function [xx,yy] = aufg83(h,iwahl);
t = h;
k = 1;
x = 1;
y = 0;
while (t < 2*pi)
if (iwahl == 1)
% Euler explizit
  r2 = x**2+y**2;
  x = x + h*y/r2;
  y = y - h*x/r2;
elseif (iwahl == 2)
% verbesserte Polygonzugmethode
  r2 = x**2+y**2;
  k11 = y/r2;k12 = -x/r2;
  r2 = (x+0.5*h*k11)**2 + (y+0.5*h*k12)**2;
  k21 = (y+0.5*h*k12)/r2; k22 = -(x+0.5*h*k11)/r2;
  x = x + h*k21;
  y = y + h*k22;
elseif (iwahl == 3)
% Heun-Verfahren 3. Ordnung
  r2 = x**2+y**2;
  k11 = y/r2;
  k12 = -x/r2;
  r2 = (x+h*k11/3)**2 + (y+h*k12/3)**2;
  k21 = (y+h*k12/3)/r2;
  k22 = -(x+h*k11/3)/r2;
  r2 = (x+2*h*k21/3)**2 + (y+2*h*k22/3)**2;
  k31 = (y+2*h*k22/3)/r2;
  k32 = -(x+2*h*k21/3)/r2;
  x = x + 0.25*h*(k11 + 3*k31);
  y = y + 0.25*h*(k12 + 3*k32);
end
t = t + h;
xx(k) = x;
yy(k) = y;
k = k + 1;
end
end
