% Programm aufg8.5b  
% 3-Schritt-Verfahren dritter Ordnung
% zur Loesung von gew. DGL 1. Ordnung y'=f(x,y), y(x0)=y0
% input:  Schrittweite h, Intervallgrenzen x0,x1, Anfangswert y0=y(x0) 
% output: Loesung y(x) an den Punkten x
% benutztes Programm: Nutzerfunktion f (rechte Seite der Dgl.) 
%      und Heun-Verfahren dritter Ordnung (heun3_gb.m) zur Berechnung
%      von y1, y2 als Startwerte fuer das 3-Schritt-Verfahren
% Aufruf: [y,x] = aufg85b(x0,x1,y0,h,epsilon)
function [y,x] = aufg85b(x0,x1,y0,h,epsilon);
n = (x1 - x0)/h;
yn = y0; y(1)=y0;
xn = x0; x(1)=x0; 
% Berechnung von y1 und y2
[y,x] = heun3_gb(x0,x0+2*h,y0,h)
yn = y(3); xn = x0+2*h;
% Berechnung von y3, y4,...
for k=3:n
   f3=f(xn+h,yn);
   f3a=f3+epsilon;
   f2=f(x(k),y(k));f1=f(x(k-1),y(k-1));f0=f(x(k-2),y(k-2));
   b = h*(38/45*f2-47/180*f1+296/4995*f0)+y(k);
   itfix = 0;
   while (abs(f3-f3a) > epsilon)
     f3a = f(xn+h,yn);
     yn = h*7141/19980*f3a + b;
     f3 = f(xn+h,yn); 
     itfix = itfix+1
     f3-f3a
   end
   xn = xn+h; x(k+1)=xn; y(k+1)=yn;
end
end
