% Programm aufg44a von-Mises-Vektoriteration
% input:  pos. definite symmertische Matrix a, Toleranz epsilon
% output: Eigenwerte und dazugehoerende Eigenvektoren
% benoetigtes Programm: aufg44.m
% aufruf: [lambda,v,iter] = aufg44a(a,epsilon);
function [lambda,v,iter] = aufg44a(a,epsilon);
n = length(a(:,1));
a1 = a;
for i=1:n
  [lambda(i),vv,iter(i)] = aufg44(a1,epsilon);
  a1 = a1 - (vv*vv')/(vv'*vv)*a1;
  v(:,i) = vv;
end
end
